import { ElementType, useState } from "react";

export const WithHocToggle = (Component: ElementType) => {
  return function WithHocToggleComponent({ ...props }: {
    [key: string]: any;
  }) {
    const [toggle, setToggle] = useState<boolean>(false);

    return (
      <Component
        toggle={(
          onTrue: string = 'show',
          onFalse: string = '',
          extraCondition: any = null
        ) => (extraCondition) || toggle ? onTrue : onFalse}
        setToggle={() => setToggle(!toggle)}
        {...props}
      />
    );
  };
};

export type ToggleType = (
  onTrue?: string,
  onFalse?: string,
  extraCondition?: any
) => string;

export type SetToggleType = () => void;
